version = "1.19.4.0"
api_endpoints = {
    "version": "/api/version",
    "customers": "/api/customers",
    "customer_by_id": "/api/customers/{customer_id}",
    "customer_basic_data": "/api/customers/{customer_id}/basic-data",
    "customer_contract_information": "/api/customers/{customer_id}/contract-information",
    "customer_subscriptions": "/api/customers/{customer_id}/subscriptions",
    "customer_feature_status": "/api/customers/{customer_id}/feature-status",
    "customer_options": "/api/customers/{customer_id}/options",
    "customer_external_numbers": "/api/customers/{customer_id}/options/external-numbers",
    "customer_default_system_integrator": "/api/customers/{customer_id}/default-system-integrator",
    "customer_category": "/api/customers/{customer_id}/category",
    "customer_snom_transfer": "/api/customers/{customer_id}/snom-transfer",
    "customer_available_pbx_groups": "/api/customers/{customer_id}/available-pbx-groups",
    "customer_operator_details": "/api/customers/{customer_id}/operator-details",
    "customer_call_recording": "/api/customers/{customer_id}/call-recording",
    "customer_port_speeds": "/api/customers/{customer_id}/port-speeds",
    "customer_uacsta_protocols": "/api/customers/{customer_id}/uacsta-protocols",
    "customer_monitoring_levels": "/api/customers/{customer_id}/monitoring-levels",
    "customer_codec_profiles": "/api/customers/{customer_id}/codec-profiles",
    "customer_count_of_trunks": "/api/customers/{customer_id}/count-of-trunks",
    "customer_evn_modes": "/api/customers/{customer_id}/evn-modes",
    "customer_cti_billing_modes": "/api/customers/{customer_id}/cti-billing-modes",
    "customer_click_to_dial_states": "/api/customers/{customer_id}/click-to-dial-states",
    "customer_nmeeting_options": "/api/customers/{customer_id}/nmeeting-options",
    "customer_available_recording_audio_types": "/api/customers/{customer_id}/available-recording-audio-types",
    "customer_available_record_start_message_recipients": "/api/customers/{customer_id}/available-record-start-message-recipients",
    "system_integrator": "/api/system-integrators/{system_integrator_id}",
    "system_integrator_customers": "/api/system-integrators/{system_integrator_id}/customers",
    "operators": "/api/operators",
    "operator_by_id": "/api/operators/{operator_id}",
    "operator_customers": "/api/operators/{operator_id}/customers",
    "operator_rating_profiles": "/api/operators/{operator_id}/rating-profiles",
    "operator_rating_profile_by_name": "/api/operators/{operator_id}/rating-profiles/{rating_profile_name}",
    "operator_available_rating_profiles": "/api/operators/{operator_id}/rating-profiles/available",
    "operator_system_integrators": "/api/operators/{operator_id}/system-integrators",
    "operator_blacklist_profiles": "/api/operators/{operator_id}/blacklist-profiles",
    "operator_blacklist_profile_by_id": "/api/operators/{operator_id}/blacklist-profiles/{blacklist_profile_id}",
    "operator_pbx_groups": "/api/operators/{operator_id}/pbx-groups",
    "operator_pbx_group_by_name": "/api/operators/{operator_id}/pbx-groups/{pbx_group_name}",
    "operator_softswitches": "/api/operators/{operator_id}/softswitches",
    "operator_softswitch_by_id": "/api/operators/{operator_id}/softswitches/{softswitch_id}",
    "device_types": "/api/customers/{customer_id}/device-types",
    "device_type_by_name": "/api/customers/{customer_id}/device-types/{device_type_name}",
    "device_type_firmwares": "/api/customers/{customer_id}/device-types/{device_type_name}/firmwares",
    "device_type_firmware_by_version": "/api/customers/{customer_id}/device-types/{device_type_name}/firmwares/{release_version}",
    "customer_devices": "/api/customers/{customer_id}/devices",
    "device_activation": "/api/customers/{customer_id}/devices/{device_category}/{device_id}/activate",
    "device_bypass_authentication": "/api/customers/{customer_id}/devices/{device_id}/bypass-authentication",
    "device_reset_authentication": "/api/customers/{customer_id}/devices/{device_id}/reset-authentication",
    "device_sip_credential_renewal": "/api/customers/{customer_id}/devices/{device_category}/{device_id}/activation-credentials-renewal",
    "device_site_options": "/api/customers/{customer_id}/devices/{device_category}/{device_id}/site-options",
    "unprovisioned_sip_devices": "/api/customers/{customer_id}/devices/unprovisioned-sip",
    "unprovisioned_sip_device": "/api/customers/{customer_id}/devices/unprovisioned-sip/{device_id}",
    "xcapi_devices": "/api/customers/{customer_id}/devices/xcapi",
    "xcapi_device": "/api/customers/{customer_id}/devices/xcapi/{xcapi_id}",
    "external_line_device_create": "/api/customers/{customer_id}/devices/external-line",
    "external_line_device": "/api/customers/{customer_id}/devices/external-line/{device_id}",
    "standard_devices": "/api/customers/{customer_id}/devices/standard",
    "standard_device": "/api/customers/{customer_id}/devices/standard/{device_id}",
    "base_devices": "/api/customers/{customer_id}/devices/base",
    "base_device": "/api/customers/{customer_id}/devices/base/{base_id}",
    "base_device_free_ports": "/api/customers/{customer_id}/devices/base/{base_id}/free-ports",
    "base_device_licenses": "/api/customers/{customer_id}/devices/base/{base_id}/licenses",
    "base_device_license": "/api/customers/{customer_id}/devices/base/{base_id}/licenses/{license_id}",
    "base_device_handsets": "/api/customers/{customer_id}/devices/base/{base_device_id}/handsets",
    "base_device_handset": "/api/customers/{customer_id}/devices/base/{base_device_id}/handsets/{handset_id}",
    "handset_activation": "/api/customers/{customer_id}/devices/base/{base_device_id}/handsets/{handset_id}/activate",
    "operator_panel": "/api/customers/{customer_id}/devices/operator-panel",
    "operator_panel_available_phones": "/api/customers/{customer_id}/devices/operator-panel/{operator_panel_id}/available-phones",
    "softphone_devices": "/api/customers/{customer_id}/devices/softphone",
    "softphone_device": "/api/customers/{customer_id}/devices/softphone/{device_id}",
    "trunks": "/api/customers/{customer_id}/trunks",
    "trunk_by_number": "/api/customers/{customer_id}/trunks/{trunk_number}",
    "trunk_available_drop_extensions": "/api/customers/{customer_id}/trunks/{trunk_number}/available-drop-extensions",
    "trunk_available_extensions": "/api/customers/{customer_id}/trunks/{trunk_number}/available-extensions",
    "dids": "/api/customers/{customer_id}/dids",
    "did_by_number": "/api/customers/{customer_id}/dids/{did_number}",
    "did_destination": "/api/customers/{customer_id}/dids/{did_number}/destination",
    "did_available_destinations": "/api/customers/{customer_id}/dids/available-destinations",
    "sites": "/api/customers/{customer_id}/sites",
    "site_by_salesforce_id": "/api/customers/{customer_id}/sites/{salesforce_id}",
    "emergency_sites": "/api/customers/{customer_id}/emergency-sites",
    "site_options": "/api/customers/{customer_id}/sites/{site_id}/site-options",
    "contract_by_salesforce_id": "/api/customers/{customer_id}/contracts/{sales_force_id}",
    "router": "/api/customers/{customer_id}/routers",
    "router_by_id": "/api/customers/{customer_id}/routers/{router_id}",
    "blacklist_profiles": "/api/customers/{customer_id}/blacklist-profiles",
    "blacklist_profile_by_id": "/api/customers/{customer_id}/blacklist-profiles/{blacklist_profile_id}",
    "voice_recording_profiles": "/api/customers/{customer_id}/voice-recording-profiles",
    "voice_recording_profile_by_id": "/api/customers/{customer_id}/voice-recording-profiles/{voice_recording_profile_id}",
    "blacklist_global_profiles": "/api/customers/{customer_id}/blacklist-global-profiles",
    "targets": "/api/customers/{customer_id}/targets",
    "target_license_subscriptions": "/api/customers/{customer_id}/targets/license-subscriptions",
    "target_license_subscription": "/api/customers/{customer_id}/targets/license-subscriptions/{extension_number}",
    "phone_extensions": "/api/customers/{customer_id}/targets/phone-extensions",
    "phone_extension": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}",
    "phone_extension_available_callforward_source": "/api/customers/{customer_id}/targets/phone-extensions/{specification}//availablespecification",
    "phone_extension_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/inbound-trunk-numbers",
    "phone_extension_inbound_trunk_number": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/inbound-trunk-numbers/{trunk_id}",
    "phone_extension_outbound_trunk_numbers": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/outbound-trunk-numbers",
    "phone_extension_outbound_trunk_number": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/outbound-trunk-numbers/{trunk_id}",
    "phone_extension_callforward_globals": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-globals",
    "phone_extension_callforward_global_reference": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-globals/{reference_type}",
    "phone_extension_callforward_profiles": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-profiles",
    "phone_extension_callforward_profile": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-profiles/{profile_number}",
    "phone_extension_callforward_profile_rules": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-profiles/{profile_number}/rules",
    "phone_extension_callforward_profile_rule": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-profiles/{profile_number}/rules/{source_id}",
    "phone_extension_callforward_profile_rule_reference": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/callforward-profiles/{profile_number}/rules/{source_id}/{reference_type}",
    "phone_extension_call_forwards": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/call-forwards",
    "phone_extension_concrete_call_forwards": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/call-forwards/{forward_type}",
    "phone_extensions_function_keys_available_targets": "/api/customers/{customer_id}/targets/phone-extensions/function-keys/available-targets",
    "phone_extension_function_keys": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/function-keys",
    "phone_extension_function_key": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/function-keys/{key_number}",
    "phone_extension_function_keys_available_targets": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/function-keys/available-targets",
    "phone_extension_devices": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/devices",
    "phone_extension_device": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/devices/{device_id}",
    "phone_extension_devices_available": "/api/customers/{customer_id}/targets/phone-extensions/devices/available",
    "phone_extension_skills": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/skills",
    "phone_extension_voice_mail": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/voice-mail",
    "phone_extension_available_internal_outgoings": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/available-internal-outgoings",
    "phone_extensions_available_internal_outgoings": "/api/customers/{customer_id}/targets/phone-extensions/available-internal-outgoings",
    "phone_extension_voice_mail_announcements": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/voice-mail/announcements",
    "phone_extension_voice_mail_announcement_type": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/voice-mail/announcements/{TEMPORARY|BUSY|UNAVAILABLE|NAME}",
    "available_cti_info": "/api/customers/{customer_id}/targets/phone-extensions/available-cti-info/{NONE|EXPRESS|CRM|nCTIStdWin|nCTIStdWinCRM|nCTIStdMac|nCTIPro}",
    "routing_prefix": "/api/customers/{customer_id}/targets/routing-prefix",
    "routing_prefix_by_extension": "/api/customers/{customer_id}/targets/routing-prefix/{extension_number}",
    "virtual_fax_extensions": "/api/customers/{customer_id}/targets/virtual-fax-extensions",
    "virtual_fax_extension": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}",
    "virtual_fax_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}/inbound-trunk-numbers",
    "virtual_fax_inbound_trunk_number": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}/inbound-trunk-numbers/{trunk_id}",
    "virtual_fax_outbound_trunk_numbers": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}/outbound-trunk-numbers",
    "virtual_fax_outbound_trunk_number": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}/inbound-trunk-numbers/{trunk_id}",
    "virtual_fax_available_trunks": "/api/customers/{customer_id}/targets/virtual-fax-extensions/{extension_number}/outbound-trunk-numbers/available-trunks",
    "queue_services": "/api/customers/{customer_id}/targets/queue-services",
    "queue_service": "/api/customers/{customer_id}/targets/queue-services/{service_number}",
    "queue_service_timeout": "/api/customers/{customer_id}/targets/queue-services/{service_number}/timeout",
    "queue_available_destinations_on_timeout": "/api/customers/{customer_id}/targets/queue-services/available-destinations-on-timeout",
    "queue_destination_on_rejection": "/api/customers/{customer_id}/targets/queue-services/{service_number}/destination-on-rejection",
    "queue_available_destinations_on_rejection": "/api/customers/{customer_id}/targets/queue-services/{service_number}/available-destinations-on-rejection",
    "queue_members": "/api/customers/{customer_id}/targets/queue-services/{service_number}/members",
    "queue_member": "/api/customers/{customer_id}/targets/queue-services/{service_number}/members/{extension_number}",
    "queue_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/queue-services/{service_number}/inbound-trunk-numbers",
    "queue_inbound_trunk_number": "/api/customers/{customer_id}/targets/queue-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "queue_available_general_announcements": "/api/customers/{customer_id}/targets/queue-services/available-general-announcements",
    "queue_available_music_on_hold_announcements": "/api/customers/{customer_id}/targets/queue-services/available-music-on-hold-announcements",
    "group_services": "/api/customers/{customer_id}/targets/group-services",
    "group_service": "/api/customers/{customer_id}/targets/group-services/{service_number}",
    "group_timeout": "/api/customers/{customer_id}/targets/group-services/{service_number}/timeout",
    "group_available_destinations_on_timeout": "/api/customers/{customer_id}/targets/group-services/available-destinations-on-timeout",
    "group_members": "/api/customers/{customer_id}/targets/group-services/{service_number}/members",
    "group_member": "/api/customers/{customer_id}/targets/group-services/{service_number}/members/{extension_number}",
    "group_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/group-services/{service_number}/inbound-trunk-numbers",
    "group_inbound_trunk_number": "/api/customers/{customer_id}/targets/group-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "skill_services": "/api/customers/{customer_id}/targets/skill-services",
    "skill_service": "/api/customers/{customer_id}/targets/skill-services/{service_number}",
    "skill_timeout": "/api/customers/{customer_id}/targets/skill-services/{service_number}/timeout",
    "skill_available_destinations_on_timeout": "/api/customers/{customer_id}/targets/skill-services/available-destinations-on-timeout",
    "skill_destination_on_rejection": "/api/customers/{customer_id}/targets/skill-services/{service_number}/destination-on-rejection",
    "skill_available_destinations_on_rejection": "/api/customers/{customer_id}/targets/skill-services/{service_number}/available-destinations-on-rejection",
    "skill_members": "/api/customers/{customer_id}/targets/skill-services/{service_number}/members",
    "skill_member": "/api/customers/{customer_id}/targets/skill-services/{service_number}/members/{extension_number}",
    "skill_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/skill-services/{service_number}/inbound-trunk-numbers",
    "skill_inbound_trunk_number": "/api/customers/{customer_id}/targets/skill-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "skill_login_status": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/skills/login-status",
    "skill_available_general_announcements": "/api/customers/{customer_id}/targets/skill-services/available-general-announcements",
    "skill_available_music_on_hold_announcements": "/api/customers/{customer_id}/targets/skill-services/available-music-on-hold-announcements",
    "conference_services": "/api/customers/{customer_id}/targets/conference-services",
    "conference_service": "/api/customers/{customer_id}/targets/conference-services/{service_number}",
    "conference_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/conference-services/{service_number}/inbound-trunk-numbers",
    "conference_inbound_trunk_number": "/api/customers/{customer_id}/targets/conference-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "ivr_services": "/api/customers/{customer_id}/targets/ivr-services",
    "ivr_service": "/api/customers/{customer_id}/targets/ivr-services/{service_number}",
    "ivr_timeout": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/timeout",
    "ivr_available_destinations_on_timeout": "/api/customers/{customer_id}/targets/ivr-services/available-destinations-on-timeout",
    "ivr_key_assignments": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/key-assignments",
    "ivr_key_assignment": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/key-assignments/{number}",
    "ivr_key_assignment_available_destinations": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/key-assignments/target-available-destinations",
    "ivr_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/inbound-trunk-numbers",
    "ivr_inbound_trunk_number": "/api/customers/{customer_id}/targets/ivr-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "ivr_available_general_announcements": "/api/customers/{customer_id}/targets/ivr-services/available-general-announcements",
    "time_control_services": "/api/customers/{customer_id}/targets/time-control-services",
    "time_control_service": "/api/customers/{customer_id}/targets/time-control-services/{service_number}",
    "time_control_available_destinations": "/api/customers/{customer_id}/targets/time-control-services/available-destinations",
    "time_control_inbound_trunk_numbers": "/api/customers/{customer_id}/targets/time-control-services/{service_number}/inbound-trunk-numbers",
    "time_control_inbound_trunk_number": "/api/customers/{customer_id}/targets/time-control-services/{service_number}/inbound-trunk-numbers/{trunk_id}",
    "phone_books": "/api/customers/{customer_id}/phone-books",
    "phone_book": "/api/customers/{customer_id}/phone-books/{phone_book_id}",
    "phone_book_visibilities": "/api/customers/{customer_id}/phone-books/{phone_book_id}/visibilities",
    "phone_book_visibility": "/api/customers/{customer_id}/phone-books/{phone_book_id}/visibilities/{extension_number}",
    "phone_book_available_phone_extensions": "/api/customers/{customer_id}/phone-books/{phone_book_id}/visibilities/available-phone-extensions",
    "lync_gateways": "/api/customers/{customer_id}/lync/gateways",
    "lync_gateway": "/api/customers/{customer_id}/lync/gateways/{lync_gateway_id}",
    "lync_sites": "/api/customers/{customer_id}/lync/sites",
    "lync_site": "/api/customers/{customer_id}/lync/sites/{lync_site_id}",
    "lync_options": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/lync",
    "lync_option": "/api/customers/{customer_id}/targets/phone-extensions/{extension_number}/lync/{lync_id}",
    "lync_device": "/api/customers/{customer_id}/devices/lync/{lync_id}",
    "announcements": "/api/customers/{customer_id}/announcements",
    "announcement": "/api/customers/{customer_id}/announcements/{announcement_id}",
    "device_types_list": "/api/device-types",
    "device_type": "/api/device-types/{device_type_name}",
    "device_type_firmwares_list": "/api/device-types/{device_type_name}/firmwares",
    "device_type_firmware": "/api/device-types/{device_type_name}/firmwares/{release_version}",
    "accounts": "/api/accounts",
    "account": "/api/accounts/{account_salesforce_id}",
    "account_sites": "/api/accounts/{account_salesforce_id}/sites",
    "account_site": "/api/accounts/{account_salesforce_id}/sites/{site_salesforce_id}",
    "sip_servers": "/api/sip-servers",
    "sip_server": "/api/sip-servers/{sip_server_id}",
    "pbx_groups": "/api/pbx-groups",
    "pbx_group": "/api/pbx-groups/{pbx_group_name}",
    "directcall_numbers": "/api/directcall-numbers",
    "directcall_number": "/api/directcall-numbers/{directcall_number}",
    "time_zones": "/api/time-zones",
    "time_zone": "/api/time-zones/{timezone}",
    "contract_types": "/api/contract-types",
    "contract_type": "/api/contract-types/{contract_type}",
    "devices": "/api/devices",
    "devices_validate_mac_address" : "/api/devices/validate-macaddress",
}
